;------------------------------------------------
;	Doors picture viewer 1.0
;	 Copyright 1998
;	The Doors Team
;------------------------------------------------

	xdef	_main
	xdef	_ti89
	xdef	_ti92plus
	xdef	_comment
	include graphlib.h
	include doorsos.h
	include userlib.h

_main	
	bra.s		debut
handle	dc.w	0			;var where doors puts the handle of the pic to view

debut	move.w	handle,d0	
	tst.w		d0			;if handle = 0
	beq		\fin			;then exit
	jsr	graphlib::clr_scr 	;clears the screen
	DEREF     d0,a0
	clr.l	d0
	move.w	(a0)+,d0		;size into d0
	cmp.b	#$DF,-1(a0,d0.w)	;is a PIC var ?
	bne	\fin			;no -> exit
	move.w		(a0)+,d0	;height into d0
	move.w		(a0)+,d1	;width into d1
	move.w		d1,d4		;copy to d4
	lsr.w		#3,d4		;divides by 8
	and.w		#7,d1		;tests if something remains
	bne		\suite		;yes -> suite
	subq.w		#1,d4		;no -> removes one

\suite	lea		LCD_MEM,a2	;video mem adress
	move.L		a2,a1		;copy to a1
	subq.w		#1,d0		;for dbra
\line	move.w		d4,d1		;copy for the dbra
\copy	move.b		(a0)+,(a2)+	;puts 8 pixels
	dbra		d1,\copy	;repeats for a line
	lea		30(a1),a1	;next line on the screen
	move.l		a1,a2		;copy to a2
	dbra		d0,\line	;loop to display all lines
	jsr	userlib::idle_hot 	;waits for a key
\fin	rts					;exits !

_comment   dc.b	 "Doors picture viewer",0

	end
